import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

class RegularTextFormFeild extends StatefulWidget {
  String title;
  String hintText;
  TextEditingController controller;
  Widget? suffix;
  String prefixText = "";
  bool isPrefix = false;
  bool isTitle = true;
  bool isPrefixIcon = false;
  String path = "";
  double radius = 12;
  double fontSize = 12;
  Color? fieldColor = Colors.white;
  bool isReadOnly = false;
  String? Function(String?)? validator;
  TextInputAction? textInputAction;
  TextInputType? keyboardType;
  int? maxline = 5;
  int? minLine = 1;
  String? Function(String?)? onchanged;

  RegularTextFormFeild({
    required String this.title,
    required String this.hintText,
    required TextEditingController this.controller,
    Widget? this.suffix,
    String prefixText = "",
    bool isPrefix = false,
    bool isTitle = true,
    bool isPrefixIcon = false,
    String path = "",
    Color this.fieldColor = Colors.white,
    double radius = 12,
    double fontSize = 12,
    bool isReadOnly = false,
    String? Function(String?)? validator,
    TextInputAction? textInputAction,
    TextInputType? keyboardType,
    int? maxline = 5,
    int? minLine = 1,
    String? Function(String?)? onchanged,
  });

  @override
  State<RegularTextFormFeild> createState() => _RegularTextFormFeildState();
}

class _RegularTextFormFeildState extends State<RegularTextFormFeild> {
  @override
  Widget build(BuildContext context) {
    return Column(
      crossAxisAlignment: CrossAxisAlignment.start,
      children: [
        widget.isTitle ? Text(widget.title) : Container(),
        widget.isTitle ? SizedBox(height: 2) : Container(),
        Container(
          // padding: const EdgeInsets.symmetric(vertical: 2, horizontal: 0),
          decoration: BoxDecoration(
            color: widget.fieldColor,
            borderRadius: BorderRadius.all(
              Radius.circular(10),
            ),
          ),
          child: Row(
            children: [
              widget.isPrefix ? Text(widget.prefixText) : Container(),
              widget.isPrefixIcon ? Image.asset(widget.path) : Container(),
              SizedBox(width: widget.isPrefix || widget.isPrefix ? 10 : 0),
              Expanded(
                child: TextFormField(
                  minLines: widget.minLine,
                  maxLines: widget.maxline,
                  cursorColor: Colors.black12,
                  controller: widget.controller,
                  decoration: InputDecoration(
                    hintText: widget.hintText,
                    filled: true,
                    fillColor: Colors.grey.withOpacity(.2),
                    focusColor: Colors.grey.withOpacity(0.05),
                    enabledBorder: OutlineInputBorder(
                      borderRadius: BorderRadius.circular(10),
                      borderSide: BorderSide(
                        color: Colors.grey.withOpacity(0.05),
                      ),
                    ),
                    focusedBorder: OutlineInputBorder(
                      borderRadius: BorderRadius.circular(10),
                      borderSide: BorderSide(
                        color: Colors.grey.withOpacity(0.05),
                      ),
                    ),
                  ),
                  validator: widget.validator,
                  readOnly: widget.isReadOnly,
                  textInputAction: widget.textInputAction,
                  keyboardType: widget.keyboardType,
                  onChanged: widget.onchanged,
                ),
              ),
            ],
          ),
        )
      ],
    );
  }
}
